"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BugSplatApiClient = void 0;
var _common_1 = require("../../index");
var BugSplatApiClient = (function () {
    function BugSplatApiClient(_host, _environment) {
        if (_host === void 0) { _host = _common_1.bugsplatAppHostUrl; }
        if (_environment === void 0) { _environment = _common_1.Environment.Node; }
        this._host = _host;
        this._environment = _environment;
        this._createFormData = function () { return new FormData(); };
        this._fetch = globalThis.fetch;
        this._headers = {};
    }
    BugSplatApiClient.createAuthenticatedClientForNode = function (email, password, host) {
        if (host === void 0) { host = _common_1.bugsplatAppHostUrl; }
        return __awaiter(this, void 0, void 0, function () {
            var client;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        client = new BugSplatApiClient(host, _common_1.Environment.Node);
                        return [4, client.login(email, password)];
                    case 1:
                        _a.sent();
                        return [2, client];
                }
            });
        });
    };
    BugSplatApiClient.createAuthenticatedClientForWebBrowser = function (email, password, host) {
        if (host === void 0) { host = _common_1.bugsplatAppHostUrl; }
        return __awaiter(this, void 0, void 0, function () {
            var client;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        client = new BugSplatApiClient(host, _common_1.Environment.WebBrowser);
                        return [4, client.login(email, password)];
                    case 1:
                        _a.sent();
                        return [2, client];
                }
            });
        });
    };
    BugSplatApiClient.prototype.createFormData = function () {
        return this._createFormData();
    };
    BugSplatApiClient.prototype.fetch = function (route, init) {
        if (init === void 0) { init = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                if (!init.headers) {
                    init.headers = {};
                }
                if (this._environment === _common_1.Environment.WebBrowser) {
                    init.credentials = 'include';
                }
                if (this._environment === _common_1.Environment.Node) {
                    init.headers ? init.headers = __assign(__assign({}, init.headers), this._headers) : null;
                }
                url = new URL(route, this._host);
                return [2, this._fetch(url.href, init)];
            });
        });
    };
    BugSplatApiClient.prototype.login = function (email, password) {
        return __awaiter(this, void 0, void 0, function () {
            var url, formData, response, cookie, xsrfToken;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = new URL('/api/authenticatev3', this._host);
                        formData = this._createFormData();
                        formData.append('email', email);
                        formData.append('password', password);
                        formData.append('Login', 'Login');
                        return [4, this._fetch(url.href, {
                                method: 'POST',
                                body: formData,
                                cache: 'no-cache',
                                redirect: 'follow'
                            })];
                    case 1:
                        response = _a.sent();
                        if (response.status === 401) {
                            throw new Error('Could not authenticate, check credentials and try again');
                        }
                        if (this._environment === _common_1.Environment.Node) {
                            cookie = this.parseCookies(response);
                            xsrfToken = this.parseXsrfToken(cookie);
                            this._headers['cookie'] = cookie;
                            this._headers['xsrf-token'] = xsrfToken;
                        }
                        return [2, response];
                }
            });
        });
    };
    BugSplatApiClient.prototype.parseCookies = function (response) {
        var _a;
        return (_a = response.headers.get('set-cookie')) !== null && _a !== void 0 ? _a : '';
    };
    BugSplatApiClient.prototype.parseXsrfToken = function (cookie) {
        var regex = new RegExp(/xsrf-token=[^;]*/g);
        var matches = cookie.match(regex);
        if (!matches) {
            throw new Error('Could not parse XSRF token');
        }
        var xsrfCookie = matches[0];
        var xsrfToken = xsrfCookie.split('=')[1];
        return xsrfToken;
    };
    return BugSplatApiClient;
}());
exports.BugSplatApiClient = BugSplatApiClient;
//# sourceMappingURL=bugsplat-api-client.js.map