"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertEventsToEventStreamEvents = void 0;
var _events_1 = require("../index");
function convertEventsToEventStreamEvents(eventsArray) {
    var results = [];
    eventsArray.forEach(function (event) {
        if (isCommentEvent(event.type)) {
            results.push((0, _events_1.createEventFromApiResponse)(event, _events_1.EventStreamActionType.comment));
        }
        else if (isDefectEvent(event.type)) {
            results.push((0, _events_1.createEventFromApiResponse)(event, _events_1.EventStreamActionType.defect));
        }
    });
    return results.reverse();
}
exports.convertEventsToEventStreamEvents = convertEventsToEventStreamEvents;
function isCommentEvent(type) {
    return type === _events_1.EventType.Comment;
}
function isDefectEvent(type) {
    return type === _events_1.EventType.AddCrashDefect
        || type === _events_1.EventType.RemoveCrashDefect
        || type === _events_1.EventType.AddStackKeyDefect
        || type === _events_1.EventType.RemoveStackKeyDefect;
}
//# sourceMappingURL=event.js.map