"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VersionsApiRow = void 0;
var argument_contracts_1 = __importDefault(require("argument-contracts"));
var VersionsApiRow = (function () {
    function VersionsApiRow(rawApiRow) {
        var _a, _b, _c;
        argument_contracts_1.default.assertType(rawApiRow, Object, 'rawApiRow');
        var symbolId;
        try {
            symbolId = Number(rawApiRow.symbolId);
        }
        catch (error) {
            throw new TypeError("symbolId should be parsable to int. Provided value: " + JSON.stringify(rawApiRow.symbolId) + ". Inner Error: " + error);
        }
        var safeAppName = (_a = rawApiRow.appName) !== null && _a !== void 0 ? _a : '';
        var safeVersion = (_b = rawApiRow.version) !== null && _b !== void 0 ? _b : '';
        var safeReportsPerDay = (_c = rawApiRow.reportsPerDay) !== null && _c !== void 0 ? _c : 0;
        this.symbolId = symbolId;
        this.appName = safeAppName;
        this.version = safeVersion;
        this.lastUpdate = rawApiRow.lastUpdate;
        this.firstReport = rawApiRow.firstReport;
        this.lastReport = rawApiRow.lastReport;
        this.size = Number(rawApiRow.size);
        this.reportsPerDay = Number(safeReportsPerDay);
        this.rejectedCount = Number(rawApiRow.rejectedCount);
        this.retired = Boolean(Number(rawApiRow.retired));
        this.fullDumps = Boolean(Number(rawApiRow.fullDumps));
        Object.freeze(this);
    }
    return VersionsApiRow;
}());
exports.VersionsApiRow = VersionsApiRow;
//# sourceMappingURL=versions-api-row.js.map