export class S3ApiClient {
    _fetch = globalThis.fetch;
    async uploadFileToPresignedUrl(presignedUrl, file) {
        const response = await this._fetch(presignedUrl, {
            method: 'PUT',
            headers: {
                'content-type': 'application/octet-stream',
                'content-length': `${file.size}`
            },
            body: file.file
        });
        if (response.status !== 200) {
            throw new Error(`Error uploading to presigned URL ${presignedUrl}`);
        }
        return response;
    }
}
//# sourceMappingURL=s3-api-client.js.map