import { createEventFromApiResponse, EventStreamActionType, EventType } from '../index';
export function convertEventsToEventStreamEvents(eventsArray) {
    const results = [];
    eventsArray.forEach((event) => {
        if (isCommentEvent(event.type)) {
            results.push(createEventFromApiResponse(event, EventStreamActionType.comment));
        }
        else if (isDefectEvent(event.type)) {
            results.push(createEventFromApiResponse(event, EventStreamActionType.defect));
        }
    });
    return results.reverse();
}
function isCommentEvent(type) {
    return type === EventType.Comment;
}
function isDefectEvent(type) {
    return type === EventType.AddCrashDefect
        || type === EventType.RemoveCrashDefect
        || type === EventType.AddStackKeyDefect
        || type === EventType.RemoveStackKeyDefect;
}
//# sourceMappingURL=event.js.map