import { SummaryApiRow } from '../summary-api-row/summary-api-row';
import { SummaryTableDataClient } from '../summary-table-data/summary-table-data-client';
export class SummaryApiClient {
    _client;
    _tableDataClient;
    constructor(_client) {
        this._client = _client;
        this._tableDataClient = new SummaryTableDataClient(this._client, '/summary?data');
    }
    async getSummary(request) {
        const response = await this._tableDataClient.postGetData(request);
        const json = await response.json();
        const pageData = json.pageData;
        const rows = json.rows.map((row) => new SummaryApiRow(row.stackKey, Number(row.stackKeyId), row.firstReport, row.lastReport, row.crashSum, row.techSupportSubject, row.stackKeyDefectId, row.stackKeyDefectUrl, row.stackKeyDefectLabel, row.comments, Number(row.subKeyDepth), Number(row.userSum)));
        return {
            rows,
            pageData
        };
    }
}
//# sourceMappingURL=summary-api-client.js.map