import ac from 'argument-contracts';
export class VersionsApiRow {
    symbolId;
    appName;
    version;
    lastUpdate;
    firstReport;
    lastReport;
    size;
    reportsPerDay;
    rejectedCount;
    retired;
    fullDumps;
    constructor(rawApiRow) {
        ac.assertType(rawApiRow, Object, 'rawApiRow');
        let symbolId;
        try {
            symbolId = Number(rawApiRow.symbolId);
        }
        catch (error) {
            throw new TypeError(`symbolId should be parsable to int. Provided value: ${JSON.stringify(rawApiRow.symbolId)}. Inner Error: ${error}`);
        }
        const safeAppName = rawApiRow.appName ?? '';
        const safeVersion = rawApiRow.version ?? '';
        const safeReportsPerDay = rawApiRow.reportsPerDay ?? 0;
        this.symbolId = symbolId;
        this.appName = safeAppName;
        this.version = safeVersion;
        this.lastUpdate = rawApiRow.lastUpdate;
        this.firstReport = rawApiRow.firstReport;
        this.lastReport = rawApiRow.lastReport;
        this.size = Number(rawApiRow.size);
        this.reportsPerDay = Number(safeReportsPerDay);
        this.rejectedCount = Number(rawApiRow.rejectedCount);
        this.retired = Boolean(Number(rawApiRow.retired));
        this.fullDumps = Boolean(Number(rawApiRow.fullDumps));
        Object.freeze(this);
    }
}
//# sourceMappingURL=versions-api-row.js.map